//ol.js
window.onload = fnInit;

function fnInit() {
    document.getElementById("btnOpen").onclick = onBtnOpenClick;
    document.getElementById("fileName").onclick = onFileClick;
    document.getElementById("btnTestOl").onclick = onTestClick;
    document.getElementById("btnTestExcel").onclick = onTestClick;
}

function onBtnOpenClick() { //read file and create table
    var efn = document.getElementById("fileName");
    var sfn = efn.value.toLowerCase();
    efn.className = "filetext";
    var esa = document.getElementById("checkShow");
    var bsa = esa.checked; //Show application if true
    var eol = document.getElementById("checkOL");
    var bol = eol.checked; //Always open in SQL Offline if true

    var bok = false;

    if (!bol && sfn.indexOf(".xls") > -1)
        bok = onOpenExcel(sfn, bsa);
    else if (sfn.indexOf(".ol") > -1) //Open OL file
        bok = onOpenOl(sfn, bsa, false);
    else //Open as a data source
        bok = onOpenOl(sfn, bsa, true);

    if (!bok) efn.className += " invalid"; //set error

    CollectGarbage(); //release app objects
    return false;
}

function onFileClick() { //clear error
    this.className = "filetext";
}

function onTestClick() {
    var sProg = "Interscape.Offline.Application";
    if (this.id == "btnTestExcel") sProg = "Excel.Application";

    var oApp; //Application object
    try {
        oApp = new ActiveXObject(sProg);
    }
    catch (err) {
        alert(err.message);
    }

    if (!oApp)
        alert("Could not load application (" + sProg + ").\n\nUnable to Initialize and script ActiveX.");
    else
        alert("Success: " + oApp.Name + " " + oApp.Version + " loaded.");

    return false;
}

function onOpenOl(sfn, bsa, bdatafile) {

    var data; // data[row][col]

    var oOlApp = new ActiveXObject("Interscape.Offline.Application");
    var oGrid;
    if (sfn && oOlApp) {
        try {
            if (bsa) oOlApp.Visible = true;
            if (bdatafile)
                oGrid = oOlApp.Documents.Use(sfn);
            else
                oGrid = oOlApp.Documents.Open(sfn);
        }
        catch (err) {
            alert(err.message);
        }
    }
    if (!oGrid) {
        return false;
    }

    //Move data to array
    var heading = new Array();
    { //read data
        for (ncol = 0; ncol < oGrid.NumCols; ncol++) {
            var oCol = oGrid.Columns(ncol + 1)
            heading[ncol] = oCol(6); //enum 6 is column name
        }
        data = fnReadData(oGrid, oGrid.NumRows, oGrid.NumCols);
    }
    if (!data) return false;

    //Place data in table
    oTable = fnCreateTable(heading, data);
    var etableGrid = document.getElementById("tableGrid");
    etableGrid.replaceNode(oTable);

    return true;
}

function onOpenExcel(sfn, bsa) {
    //Read from Excel
    var oExcelApp = new ActiveXObject("Excel.Application");
    var oDoc;
    if (sfn && oExcelApp) {
        try {
            if (bsa) oExcelApp.Visible = true;
            var oExcelBook = oExcelApp.Workbooks.Open(sfn);
            var oExcelSheet = oExcelBook.ActiveSheet;
            oDoc = oExcelSheet;
        }
        catch (err) {
            alert(err.message);
        }
    }

    if (!oDoc) {
        if (oExcelApp && !bsa) oExcelApp.Quit();
        return false;
    }

    //Move data to array
    var data;
    var heading = new Array();
    { //read data
        for (var cv, ncols = 0; cv = oDoc.Cells(1, ncols + 1).value; ncols++) {
            heading[ncols] = cv;
        }

        //count rows (first column cannot be blank)
        for (nrows = 0; oDoc.Cells(nrows + 2, 1).value; nrows++);

        if (ncols) {
            data = fnReadData(oDoc.Cells, nrows, ncols);
        }
        else {
            alert("No data to read: " + nrows + " rows and " + ncols + " columns. \n\nThe first row is used to count columns, and the first column is used to count rows. Counting stops with the first blank value.\n\nThis means tha if the first cell(1,1) is blank, no data is read.");
        }
    }

    if (!data) return false;

    //Place data in table
    oTable = fnCreateTable(heading, data);
    var etableGrid = document.getElementById("tableGrid");
    etableGrid.replaceNode(oTable);

    //oExcelApp.Quit();
    return true;
}

function fnReadData(oDoc, nrows, ncols) {
    //Populate data into array
    var sapp = oDoc.Application.Name;
    var data = new Array();
    if (nrows && ncols) {
        for (var i = 0; i < nrows; i++) {
            data[i] = new Array;
            for (var j = 0; j < ncols; j++) {
                var cv;
                //Get cell value
                if (sapp == "Microsoft Excel")
                    cv = oDoc.Cells(i + 2, j + 1).value;
                else if (sapp == "Offline")
                    cv = oDoc.Cell(j + 1, i + 1);
                else
                    alert("Unexpected: " + sapp);
                data[i][j] = cv;
            }
        }
    }
    return data;
}

function fnCreateTable(heading, data) {
    //heading[col], data[row][col]
    var oTable = document.createElement("TABLE");
    var oTHead = document.createElement("THEAD");
    var oTBody = document.createElement("TBODY");
    var oRow, oCell;
    var i, j;

    // Insert the created elements into oTable.
    oTable.appendChild(oTHead);
    oTable.appendChild(oTBody);

    // Insert a row into the header and set its background color.
    oRow = document.createElement("TR");
    oTHead.appendChild(oRow);

    // Create and insert cells into the header row.
    for (i = 0; i < heading.length; i++) {
        oCell = document.createElement("TH");
        oCell.innerHTML = heading[i];
        oRow.appendChild(oCell);
    }

    // Insert rows and cells into bodies.
    for (i = 0; i < data.length; i++) {
        oRow = document.createElement("TR");
        oTBody.appendChild(oRow);
        for (j = 0; j < data[i].length; j++) {
            oCell = document.createElement("TD");

            var c = data[i][j];
            var cs=null; try { //convert to string, blasting through unknown data types
                cs = String(c);
            } catch (e) { };

            oCell.className = typeof(c);
            oCell.innerHTML = cs;
            oRow.appendChild(oCell);
        }
    }

    oTable.id = "tableGrid";
    return oTable;
}

//end
